<template>
    <div id="player"></div>
</template>

<script>
import { mapState } from 'vuex';

export default {
    created() {
        this.parseURL();
        this.$store.dispatch('createYoutubePlayer', {
            height: this.height,
            width: this.width,
            videoId: this.videoId,
            events: {
                onReady: this.onPlayerReady,
                onError: this.onPlayerError,
            },
        });
    },
    beforeDestroy() {
        this.stopVideo();
    },
    computed: {
        ...mapState({
            player: state => state.youtube.player,
        }),
    },
    data() {
        return {
            videoId: '',
            startTime: 0,
            error: false,
        };
    },
    props: {
        /** width of YT player */
        width: {
            type: String,
            required: false,
            default: '640',
        },
        /** height of YT player */
        height: {
            type: String,
            required: false,
            default: '360',
        },
        /** youtube video URL */
        url: {
            type: String,
            required: false,
            default: '',
        },
    },
    methods: {
        /** Handler on initializing YT player */
        onPlayerReady() {
            if (this.player) {
                this.player.seekTo(this.startTime, true);
                this.player.playVideo();
            }
        },
        /** Handler on stoppiong YT video */
        stopVideo() {
            if (this.player) {
                this.player.stopVideo();
                this.player.clearVideo();
            }
        },
        /**
         * Handler for YT Player's errors
         * @param {Object} event - error event from YT API
         * */
        onPlayerError(event) {
            if (!this.error) {
                this.$store.dispatch('handleApiError', {
                    title: `Youtube Error code: ${event.data}`,
                    message: `Can't play video by URL ${this.url}`,
                });
            }
            this.error = true;
        },
        /** Parsing of youtube URL */
        parseURL() {
            // eslint-disable-next-line
            const regExp = /^.*(youtu\.be\/|v\/|u\/\w\/|embed\/|watch\?v=|\&v=)([^#\&\?]*)(?:(\?t|\&t|&start)=(\d+))?.*/;
            const match = this.url.match(regExp);
            if (match) {
                const [,, videoId,, startTime] = match;
                if (videoId && videoId.length === 11) {
                    this.videoId = videoId;
                }
                if (startTime) {
                    this.startTime = startTime;
                }
            }
        },
    },
};
</script>
